config/routes.rb
Rails.application.routes.draw do
  post 'reviews/create'
  root 'places#index'
  resources :places
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  ActiveAdmin.routes(self)
    resources :places
    resources :users
    resources :reviews
    resources :categories
end

app/models/ability.rb
# frozen_string_literal: true

class Ability
  include CanCan::Ability

  def initialize(user)
    can :read, Place

    if user.present?  # additional permissions for logged in users (they can read their own posts)
      can :read, Place, user_id: user.id
      can :create, Place, user_id: user.id
      if user.is_admin?  # additional permissions for administrators
        can :manage, ActiveAdmin::Page
      end
    end
    # Define abilities for the passed in user here. For example:
    #
    #   user ||= User.new # guest user (not logged in)
    #   if user.admin?
    #     can :manage, :all
    #   else
    #     can :read, :all
    #   end
    #
    # The first argument to `can` is the action you are giving the user
    # permission to do.
    # If you pass :manage it will apply to every action. Other common actions
    # here are :read, :create, :update and :destroy.
    #
    # The second argument is the resource the user can perform the action on.
    # If you pass :all it will apply to every resource. Otherwise pass a Ruby
    # class of the resource.
    #
    # The third argument is an optional hash of conditions to further filter the
    # objects.
    # For example, here the user can only update published articles.
    #
    #   can :update, Article, :published => true
    #
    # See the wiki for details:
    # https://github.com/CanCanCommunity/cancancan/wiki/Defining-Abilities
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/category.rb
class Category < ApplicationRecord
  has_many :places , dependent: :destroy
end

app/models/place.rb
class Place < ApplicationRecord
  has_many :reviews, dependent: :destroy
  has_many :users, through: :reviews 

  belongs_to :category
  belongs_to :user
  has_many_attached :pictures
  has_one_attached :main
end

app/models/review.rb
class Review < ApplicationRecord
  belongs_to :place
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable

  has_many :reviews, dependent: :destroy
  has_many :places, through: :reviews 

  has_many :places , dependent: :destroy
  has_many_attached :images
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :configure_permitted_parameters, if: :devise_controller?

  rescue_from CanCan::AccessDenied do |exception|
      respond_to do |format|
        format.json { head :forbidden }
        format.html { redirect_to main_app.root_url, notice: exception.message }
      end
  end

  def access_denied(exception)
    redirect_to root_path, alert: exception.message
  end

  private

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:email])
    devise_parameter_sanitizer.permit(:account_update, keys: [:email])
  end
end

app/controllers/places_controller.rb
class PlacesController < ApplicationController
  before_action :set_place, only: [:show]

  def index
    @places = Place.all
    # @categoried_places = Place.find(params[:category_id]) 
  end

  def new
    @place = Place.new
  end

  def create
    @place = Place.new(place_params)
    @place.user_id = current_user.id
    if @place.save
      flash[:notice] = "Ваше заведение находится на модерации и будет добавлено после одобрения администратором"
      redirect_to root_path
    else
      render 'new'
    end
  end

  def show
  end

  private

  def set_place
    @place = Place.find(params[:id])
  end

  def place_params
    params.require(:place).permit(:title, :category_id, :description, :main, :user_id, :pictures[])
  end

end

app/controllers/reviews_controller.rb
class ReviewsController < ApplicationController
  before_action :find_place
  
  def create
    if already_reviewed? 
      flash[:notice] = "You can't reviewed more than once"
    else
      @place.reviews.user_id = current_user.id
      @place.reviews.create(review_params)
    end
  end

  private

  def review_params
    params.require(:review).permit(:interior, :service, :food_quality, :comment, :user_id, :place_id)
  end

  def find_place
    @place = Place.find(params[:place_id])
  end

  def already_reviewed?
    Review.where(review_params).exists?
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/places_helper.rb
module PlacesHelper
end

app/helpers/reviews_helper.rb
module ReviewsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>CafeCritic</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <div>
      <%= render 'layouts/application/navbar' %>
    </div>  
    <div class="container">
      <p class="notice"><%= notice %></p>
      <p class="alert"><%= alert %></p>
      
      <%= yield %>
    </div>
  </body>
</html>

app/views/layouts/application/_navbar.html.erb
<nav class="navbar navbar-dark bg-dark navbar-expand-md">
    <div class="container">
        <button type="button" class="navbar-toggler collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
          <span class="sr-only">Toggle navigation</span>
          &#x2630;
        </button>

        <%= link_to 'Cafe Critic', root_path, class: 'navbar-brand' %>

        <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
            <div class="navbar-nav ml-auto">
              <% if user_signed_in? %>

              <div class="nav-item">
                <span class="navbar-text">
                  Hello,&nbsp;
                <span>
              </div>

              <div class="dropdown show">
                <%= link_to current_user.email, edit_user_registration_path(current_user), class: 'btn btn-secondary dropdown-toggle', 'role' => "button", 'id' => "dropdownMenuLink", 'data-toggle' => "dropdown", 'aria-haspopup' => "true", 'aria-expanded' => "false" %>
                <div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
                  <%= link_to 'Edit profile', edit_user_registration_path(current_user), class: 'dropdown-item' %>
                  <%= link_to 'Sign out', destroy_user_session_path, method: :delete, class: 'dropdown-item' %>
                </div>
              </div>
              <div class="nav-item">
                  <%= link_to 'Add new place', new_place_path, class: 'nav-link' %>
              </div>             
              <% else %>
                  <div class="nav-item">
                     <%= link_to 'Sign up', new_user_registration_path, class: 'nav-link' %>
                  </div>
                  <div class="nav-item">
                     <%= link_to 'Log in', new_user_session_path, class: 'nav-link' %>
                  </div>
              <% end %>
            </div>
        </div>
    </div>
</nav>

app/views/places/_form.html.erb
<%= simple_form_for @place,
  wrapper: :horizontal_form,
  wrapper_mappings: {
    boolean:       :horizontal_boolean,
    check_boxes:   :horizontal_collection,
    date:          :horizontal_multi_select,
    datetime:      :horizontal_multi_select,
    file:          :horizontal_file,
    radio_buttons: :horizontal_collection,
    range:         :horizontal_range,
    time:          :horizontal_multi_select
  } do |f| %>
<%= f.input :title %>
<%= f.association :category %>
<%= f.input :description, as: :text %>
<%= f.input :main %>
<%= f.button :submit %>
<% end %>

app/views/places/index.html.erb
<p id="notice"><%= notice %></p>

<h1>All places</h1>
<h5>Select category: <%= link_to 'All', places_path %>,
  <% @places.each do | place | %>
    <%= link_to place.category.title, places_path %>,
  <% end %>
</h5>

<div class="row justify-content-start mt-4">
  <% @places.each do |place| %>
  <div class="col-3 m-3">
    <div class="card" style="width: 18rem;">
      <%= image_tag place.main, :class => "card-img-top" , size: 150%>
      <div class="card-body">
          <%= link_to place.title, place_path(place) %>
      </div>
    </div>
  </div>
  <% end %>
</div>

app/views/places/new.html.erb
<h1>Add new place</h1>
<%= render 'form' , post: @place %>

app/views/places/show.html.erb
<div class="media">
  <div class="media-body">
    <h1><%= @place.title %></h1>
    <h5 class="mt-0 mb-1"><%= @place.category.title %></h5>
    <%= @place.description %>
  </div>
  <%= image_tag @place.main, :class => "ml-3" , size: 150 %>
</div>
<div class="mt-3">
  <h6>Gallery</h6>
  <%= @place.pictures.each do |picture| %>
  <%= image_tag @place.picture, size: 50 %>
  <% end %>
</div>
<div class="mt-3">
  <h6>Raitings</h6>
  <p>Overall: <%= [@place.reviews.average(:food_quality).to_f, @place.reviews.average(:service).to_f, @place.reviews.average(:interior).to_f].inject{ |sum, el| sum + el }.to_f / 3 %></p>
  <p>Quality of food: <%= @place.reviews.average(:food_quality).to_f %></p>
  <p>Service quality: <%= @place.reviews.average(:service).to_f %></p>
  <p>Interior: <%= @place.reviews.average(:interior).to_f %></p>
</div>
<div class="mt-3">
  <h6>Reviews</h6>
  <% @place.reviews.each do |review| %>
  <p>On <%= review.created_at.strftime('%Y-%m-%d') %>, <%= review.user.email %> said:</p>
  <p><%= review.comment %></p>
  <p>Quality of food: <%= review.food_quality.to_f %></p>
  <p>Service quality: <%= review.service.to_f %></p>
  <p>Interior: <%= review.interior.to_f %></p>
  <% end %>
</div>
<div class="mt-3">
  <h6>Add reviews</h6>
</div>

app/views/reviews/_form.html.erb
<%= simple_form_for @place.reviews.new,
  wrapper: :horizontal_form,
  wrapper_mappings: {
    boolean:       :horizontal_boolean,
    check_boxes:   :horizontal_collection,
    date:          :horizontal_multi_select,
    datetime:      :horizontal_multi_select,
    file:          :horizontal_file,
    radio_buttons: :horizontal_collection,
    range:         :horizontal_range,
    time:          :horizontal_multi_select
  } do |f| %>
<%= f.input :comment, as: :text %>
<%= f.input :food_quality %>
<%= f.input :service %>
<%= f.input :interior %>
<%= f.button :submit %>
<% end %>